
; AMBIENT VARS
Const BS_ColorSteps% = 3600 * 5
Global BS_SunSpeed# = 0.03
Global BS_SunAngle#	= 100.0 ; 90 Sunrise  ; 190 full day
Global BS_Time = Int( BS_SunAngle*( BS_ColorSteps / 360.0 ))
Global BS_LastAngle#
Global Sky, Sun, Moon, Clouds, Sun_Piv
Global Suntex, Moontex

Global SkyColorR#[BS_ColorSteps], SkyColorG#[BS_ColorSteps], SkyColorB#[BS_ColorSteps]
Global SkyColor2R#[BS_ColorSteps], SkyColor2G#[BS_ColorSteps], SkyColor2B#[BS_ColorSteps]

Global AmbientR#[BS_ColorSteps], AmbientG#[BS_ColorSteps], AmbientB#[BS_ColorSteps]
Global WaterAmbientR#[BS_ColorSteps], WaterAmbientG#[BS_ColorSteps], WaterAmbientB#[BS_ColorSteps]
Global LightR#[BS_ColorSteps], LightG#[BS_ColorSteps], LightB#[BS_ColorSteps]
Global SunLightRange#[BS_ColorSteps]
Global SunAlpha#[BS_ColorSteps]
Global MoonAlpha#[BS_ColorSteps]
Global BloomPower#[BS_ColorSteps]
Global BloomPower2#[BS_ColorSteps]

; -- Gradients
Dim BS_GradientPercent#(0),BS_GradientRed#(0),BS_GradientGreen#(0),BS_GradientBlue#(0)

Restore BS_SkyColor				: BS_CreateGradient(9,BS_ColorSteps,False,SkyColorR,SkyColorG,SkyColorB)
Restore BS_SkyColorTop			: BS_CreateGradient(9,BS_ColorSteps,False,SkyColor2R,SkyColor2G,SkyColor2B)

Restore BS_Ambientlight			: BS_CreateGradient(9,BS_ColorSteps,False,AmbientR,AmbientG,AmbientB)
Restore BS_LightColor			: BS_CreateGradient(9,BS_ColorSteps,False,LightR,LightG,LightB)
Restore BS_SunLightRange		: BS_CreateGradient(9,BS_ColorSteps,False,SunLightRange,SunLightRange,SunLightRange)
Restore BS_MoonAlpha			: BS_CreateGradient(9,BS_ColorSteps,False,MoonAlpha,MoonAlpha,MoonAlpha)
Restore BS_SunAlpha				: BS_CreateGradient(7,BS_ColorSteps,False,SunAlpha,SunAlpha,SunAlpha)
Restore BS_BloomPower			: BS_CreateGradient(9,BS_ColorSteps,False,BloomPower,BloomPower,BloomPower)
Restore BS_BloomPower2			: BS_CreateGradient(9,BS_ColorSteps,False,BloomPower2,BloomPower2,BloomPower2)

;////

Global Flat_Plane



Function Init_Sky()

Shader_Sky = xLoadFXFile("sky.fx")

; -- Flat Plane
Flat_Plane = xCreateMesh()
Surface = xCreateSurface(Flat_Plane)
xAddVertex Surface, -1, 1, 0, 0, 0
xAddVertex Surface,  1, 1, 0, 1, 0
xAddVertex Surface, -1,-1, 0, 0, 1
xAddVertex Surface,  1,-1, 0, 1, 1
xAddTriangle Surface, 0, 1, 2
xAddTriangle Surface, 3, 2, 1
xFlipMesh Flat_Plane
xUpdateNormals Flat_Plane
xHideEntity Flat_Plane

; -- Sky Mesh
Sky = xLoadMesh("sky/skysphere.b3d")
xScaleEntity Sky, 600, 600, 600
xFlipMesh Sky
xSetEntityEffect ( Sky, Shader_Sky )
xSetEffectTechnique ( Sky, "Sky" )


Local StarsTexture = xLoadTexture("sky/texture-stars.tga")
Local StarsMaskTex = xLoadTexture("sky/texture-stars_mask.tga")
xSetEffectTexture( Sky, "StarsTex", StarsTexture )
xSetEffectTexture( Sky, "StarsMaskTex", StarsMaskTex )


; -- Cloud Mesh
Clouds = xLoadMesh("sky/clouds.b3d")
xScaleEntity Clouds,500,80,500
xPositionEntity Clouds,0,200,0

Local cloud01 = xLoadTexture("sky/CloudsDensity.png",2)
Local cloud02 = xLoadTexture("sky/Clouds.png",2)
Local cloud03 = xLoadTexture("sky/CloudsN.png")


xSetEntityEffect ( Clouds, Shader_Sky )
xSetEffectTechnique ( Clouds, "Clouds" )
xSetEffectTexture( Sky, "CloudsTex1", cloud01 )
xSetEffectTexture( Sky, "CloudsTex2", cloud02 )
xSetEffectTexture( Sky, "CloudsTex3", cloud03 )


; -- Day/Night Pivot
Sun_Piv = xCreatePivot()


; -- Sun & Moon
Suntex = xLoadTexture( "sky/sun1.dds", 2 )
Moontex = xLoadTexture( "sky/luna_01.dds", 2 )

Moon = xCopyEntity( Flat_Plane )
xScaleEntity Moon, 140, 140, .0001
xEntityTexture Moon, Moontex
xEntityFX Moon, 9
xEntityColor Moon, 185, 185, 185

Sun = xCopyEntity( Flat_Plane )
xScaleEntity Sun, 140, 140, .0001
xEntityTexture Sun, Suntex
xEntityFX Sun , 9
xEntityColor Sun, 250, 200, 100

xEntityParent Sun, Sun_Piv
xMoveEntity Sun,0, 0, -5000
xEntityParent Moon, Sun_Piv
xMoveEntity Moon, 0, 0, 5000



End Function





Function Update_Ambient(CAMERA, LIGHT_Sun)

	BS_SunAngle = BS_SunAngle + .03

	xRotateEntity Sun, ((BS_SunAngle) - 90 ),0,0,1
	xRotateEntity Moon, ((BS_SunAngle) + 90 ),0,0,1
	
	xPositionEntity Sun_Piv, xEntityX(CAMERA), 0, xEntityZ(CAMERA)
	xPositionEntity Sky, xEntityX(CAMERA), 0, xEntityZ(CAMERA)
	

	If BS_SunAngle# <> BS_LastAngle#


		BS_SunAngle = BS_SunAngle Mod 360.0 : If BS_SunAngle<0 Then BS_SunAngle=360.0
		BS_Time = Int( BS_SunAngle * (BS_ColorSteps / 360.0 ))

		

		xRotateEntity LIGHT_Sun, BS_SunAngle - 90, 0, 0, 1
		xRotateEntity Sun_Piv, BS_SunAngle - 90, 0, 0, 1

		
		xSetEffectVector Sky, "skycolor", (Float(SkyColorR[BS_Time]) / 255) , (Float(SkyColorG[BS_Time]) / 255) , (Float(SkyColorB[BS_Time]) / 255)
		xSetEffectVector Sky, "skycolor2", (Float(SkyColor2R[BS_Time]) / 255) , (Float(SkyColor2G[BS_Time]) / 255) , (Float(SkyColor2B[BS_Time]) / 255)

		xSetEffectFloat Sky, "StarsAlp", (Float(MoonAlpha[BS_Time]) / 255) 
		
		BS_CloudMove#=(BS_SunAngle/360.0) * 5
		xSetEffectFloat Clouds, "CloudsPos", BS_CloudMove
		
		

		xSetPostEffectFloat PostProcess_Bloom, "bloom_power", ( Float(BloomPower[BS_Time]) / 100 )
		xSetPostEffectFloat PostProcess_Bloom, "bloom_power2", ( Float(BloomPower2[BS_Time]) / 100 )
		

		
		xEntityAlpha Sun,Float(SunAlpha[BS_Time])/100
		xEntityAlpha Moon,Float(MoonAlpha[BS_Time])/100	
		
		
		BS_LastAngle# = BS_SunAngle#
		
	EndIf
		xSetEffectVector Clouds, "CloudColor", .8,.8,.8 ; .2
		xSetEffectFloat Clouds, "CloudPower", .8
		
		
		xLightColor LIGHT_Sun, LightR[BS_Time], LightG[BS_Time], LightB[BS_Time]
		
		xLightRange LIGHT_Sun, Float(SunLightRange[BS_Time]) / 10
		
		xAmbientLight AmbientR[BS_Time],AmbientG[BS_Time],AmbientB[BS_Time]
	
End Function






Function BS_CreateGradient(colors%,steps%,inverse=False,R#[BS_ColorSteps],G#[BS_ColorSteps],B#[BS_ColorSteps])
	
	Dim BS_GradientPercent#(colors)
	Dim BS_GradientRed#(colors),BS_GradientGreen#(colors),BS_GradientBlue#(colors)
	
	Local i#,pos1#,pos2#,pdiff#
	Local rdiff#,gdiff#,bdiff#
	Local rstep#,gstep#,bstep#
	Local counter%=0
	
	; read data, inverse if set
	If inverse Then
		For i=colors To 1 Step -1
			Read BS_GradientPercent(i),BS_GradientRed(i),BS_GradientGreen(i),BS_GradientBlue(i)
			BS_GradientPercent(i)=100.0-BS_GradientPercent(i)
		Next
	Else
		For i=0 To colors-1
			Read BS_GradientPercent(i),BS_GradientRed(i),BS_GradientGreen(i),BS_GradientBlue(i)
		Next
	EndIf
	
	; gradient loop
	While counter<colors
		
		; convert percent to step position
		pos1=BS_GradientPercent(counter)*steps*1.0/100
		pos2=BS_GradientPercent(counter+1)*steps*1.0/100
		
		; calc delta and steps
		pdiff=pos2-pos1
		rdiff=BS_GradientRed(counter)-BS_GradientRed(counter+1)
		gdiff=BS_GradientGreen(counter)-BS_GradientGreen(counter+1)
		bdiff=BS_GradientBlue(counter)-BS_GradientBlue(counter+1)
		rstep#=rdiff*1.0/pdiff
		gstep#=gdiff*1.0/pdiff
		bstep#=bdiff*1.0/pdiff
		
		; calc new colors and store to blitzarray
		For i=0 To pdiff
			
			R[pos1+i]=(BS_GradientRed(counter)-(rstep*i))
			G[pos1+i]=(BS_GradientGreen(counter)-(gstep*i))
			B[pos1+i]=(BS_GradientBlue(counter)-(bstep*i))
			
		Next
		
		; increase counter
		counter=counter+1
		
	Wend
	
End Function


Function BS_CalculateTime$()
	
	Local time%=BS_SunAngle*4
	Local hours%=Int(Floor(time/60.0))
	Local minutes%=time-(hours*60)
	
	Return BS_ZERO(hours)+":"+BS_ZERO(minutes)
	
	
End Function


; -----------------------------------------------------------------------------------------------
; Adds BS_ZEROs in front of single digit numbers (ex. 9->09)
; -----------------------------------------------------------------------------------------------
Function BS_ZERO$(number%,lenght%=2)
	
	Local i%,r$
	
	For i=0 To lenght-Len(Str(number))-1 : r$=r$+"0" : Next
	Return r$+Str(number)
	
End Function


; AMBIENT DATA

.BS_SkyColor
Data   0.0,  15,  27,  45
Data  15.0,  15,  27,  45
Data  25.0, 243, 212, 157 ; Sunrise 
Data  35.0, 173, 191, 217
Data  50.0, 173, 191, 217
Data  65.0, 173, 191, 217
Data  75.0, 245, 202, 147 ; Sunset
Data  85.0,  15,  27,  45
Data 100.0,  15,  27,  45

.BS_SkyColorTop
Data   0.0, 15, 12, 15
Data  15.0, 15, 12, 15
Data  25.0, 37, 42, 60 ; Sunrise 
Data  35.0, 40, 54, 85
Data  50.0, 40, 54, 85
Data  65.0, 40, 54, 85
Data  75.0, 36, 34, 33 ; Sunset
Data  85.0, 15, 12, 15
Data 100.0, 15, 12, 15

.BS_Ambientlight
Data   0.0, 110, 110, 130
Data  15.0, 110, 110, 130
Data  25.0,	128,  96,  64
Data  35.0,	128, 128, 128
Data  50.0,	128, 128, 128
Data  65.0,	128, 128, 128
Data  75.0,	128,  96,  64
Data  85.0, 110, 110, 130
Data 100.0, 110, 110, 130

.BS_LightColor
Data   0.0,   0,  0,  0
Data  15.0,   0,  0,  0
Data  25.0,	225,192,128
Data  35.0,	230,230,220
Data  50.0,	230,230,220
Data  65.0,	230,230,220
Data  75.0, 225,192,128 
Data  85.0,   0,  0,  0
Data 100.0,   0,  0,  0

.BS_SunLightRange
Data   0.0, 0, 0, 20
Data  10.0, 0, 0, 20
Data  25.0, 0, 0, 20
Data  35.0, 0, 0, 10
Data  50.0, 0, 0, 10
Data  65.0, 0, 0, 10
Data  75.0, 0, 0, 20
Data  90.0, 0, 0, 20
Data 100.0, 0, 0, 20


.BS_SunAlpha
Data   0.0,   0,   0,   0
Data  15.0,   0,   0,   0
Data  20.0,  10,  10,  10
Data  25.0,  20,  20,  20
Data  50.0, 100, 100, 100
Data  75.0,  50,  50,  50
Data  80.0,  10,  10,  10
Data  85.0,   0,   0,   0
Data 100.0,   0,   0,   0

.BS_MoonAlpha
Data   0.0, 60, 60, 60
Data  15.0, 60, 60, 60
Data  20.0,  7,  7,  7
Data  25.0,  0,  0,  0
Data  50.0,  0,  0,  0
Data  75.0,  0,  0,  0
Data  80.0,  7,  7,  7
Data  85.0, 60, 60, 60
Data 100.0, 60, 60, 60



.BS_BloomPower
Data   0.0, 280, 280, 280
Data  15.0, 280, 280, 280
Data  20.0, 280, 280, 280
Data  25.0, 230, 230, 230
Data  50.0, 220, 220, 220
Data  75.0, 230, 230, 230
Data  80.0, 280, 280, 280
Data  85.0, 280, 280, 280
Data 100.0, 280, 280, 280

.BS_BloomPower2
Data   0.0,  55, 55, 55
Data  15.0,  55, 55, 55
Data  20.0,  70, 70, 70
Data  25.0,  70, 70, 70
Data  50.0,  70, 70, 70
Data  75.0,  70, 70, 70
Data  80.0,  70, 70, 70
Data  85.0,  55, 55, 55
Data 100.0,  55, 55, 55

;~IDEal Editor Parameters:
;~C#Blitz3D