;Include "xors3d.bb"
Include "d:\tools\blitz3d\userlibs\xors3d.bb"
Include "Sky.bb"

Global ResX = 1024
Global ResY = 768

SeedRnd MilliSecs()

xCreateLog()

; MOUSE
Global MouseSpeed#       = 0.5 
Global CameraSmoothness# = 10.5
Global CamYA#, CamXA#
;/////


; WATER
Global Ratio#
Global WaterRes# = 512
Global wCamera%
Global tTextureScreen, tTextureReflection
;/////

; LightScattering VARS
Global LightScattering_Samples = 50
Global BlackLS
Local BlackTexX# = Float( ResX ) / 2
Local BlackTexY# = Float( ResY ) / 2
;/////


xGraphics3D ResX,ResY,32,0,1
xCreateDSS 2048,2048



light = xCreateLight()

Init_Sky()

Floor_ = xCopyEntity (Flat_Plane)
xScaleEntity Floor_ , 10000,10000,10000
xRotateEntity Floor_,-90,0,0
xPositionEntity Floor_,0,-10,0
xEntityColor Floor_,50,50,50

xRotateEntity LIGHT, BS_SunAngle - 90, 0, 0
xRotateEntity Sun_Piv, BS_SunAngle - 90, 0, 0

Global Cam = xCreateCamera()

xPositionEntity Cam,0,80,-80
xCameraRange Cam, 1, 6500

;  Shaders ////////////////////
Global Shader_Depth = xLoadFXFile("depthnew.fx")
Global Shader_Water = xLoadFXFile("water.fx")
Global PostProcess_Bloom = xLoadPostEffect("bloom.fx")
Global PostPtocess_LightSca = xLoadPostEffect("lightsca.fx")
xSetPostEffect( 0, PostPtocess_LightSca )
xSetPostEffect( 1, PostProcess_Bloom )

; -- LIGHT Scattering
Global BlackTex = xCreateTexture( BlackTexX, BlackTexY ) 
xSetPostEffectTexture (PostPtocess_LightSca,"BlackTexture", BlackTex)
xSetPostEffectFloat (PostPtocess_LightSca,"numSamples", LightScattering_Samples)

; -- DEPTH
Global DepthTex = xCreateTexture( ResX, ResY, 4096 )
;//////////////////////////////////////////////



; -- Water Plane
Dim vx2%(0,0)
Global Water_Plane = CreateWaterPlane(150, 150, 1)
;//////////////////////////////////////////////

LoadWater(Water_Plane)

sphere = xCreateSphere()
xScaleEntity sphere,65,8,65
xPositionEntity sphere,0,-5,0
xEntityColor sphere,100,100,120



; Add entities to the depth
Global Depth_PivotNormal = xCreatePivot()
Global Depth_PivotInstances = xCreatePivot()

; Depth Normal
xEntityParent sphere, Depth_PivotNormal

; Depth Instances
; xEntityParent InstanceMesh, Depth_PivotInstances


xSetEntityEffect Depth_PivotNormal,Shader_Depth,5
xSetEffectTechnique Depth_PivotNormal, "Depth",5


xSetEntityEffect Depth_PivotInstances,Shader_Depth,5
xSetEffectTechnique Depth_PivotInstances, "DepthInstances",5


Local DepthEntities_Normal = xCountChildren ( Depth_PivotNormal )-1
Local DepthEntities_Instances = xCountChildren ( Depth_PivotInstances )-1



CamYA = 50

While Not xKeyHit(1)

	
	
	speed# = .5
	If xKeyDown(42) speed# = 1
	If xKeyDown(KEY_W) Then xMoveEntity Cam,  0,  0,  speed
	If xKeyDown(KEY_S) Then xMoveEntity Cam,  0,  0, -speed
	If xKeyDown(KEY_A) Then xMoveEntity Cam, -speed,  0,  0
	If xKeyDown(KEY_D) Then xMoveEntity Cam,  speed,  0,  0
	mxs# = CurveValue(xMouseXSpeed() * MouseSpeed, mxs, CameraSmoothness)
	mys# = CurveValue(xMouseYSpeed() * MouseSpeed, mys, CameraSmoothness)
	CamXA# = CamXA - mxs Mod 360
	CamYA# = CamYA + mys
	If CamYA < -89 Then CamYA = -89
	If CamYA >  89 Then CamYA =  89
	xMoveMouse xGraphicsWidth() / 2, xGraphicsHeight() / 2
	xRotateEntity Cam, CamYA, CamXA, 0.0
	
;	If xKeyDown(KEY_UP)
;		BS_SunSpeed = BS_SunSpeed + 0.0005
;	EndIf
;	If xKeyDown(KEY_DOWN)
;		BS_SunSpeed = BS_SunSpeed - 0.0005
;	EndIf

	; DEPTH PASS //////////////////////////////
	xWireframe 0 ; debug
	xCameraClsColor Cam, 255,255,255
	For D = 0 To DepthEntities_Normal xSetEntityShaderLayer ( xGetChild( Depth_PivotNormal, D ), 5 ) : Next
	For D = 0 To DepthEntities_Instances xSetEntityShaderLayer ( xGetChild( Depth_PivotInstances, D ), 5 ) : Next
	
	xSetBuffer xTextureBuffer ( DepthTex )
	xRenderEntity ( Cam, Depth_PivotNormal )
	xCameraClsMode ( Cam, 0, 0 )
	xRenderEntity ( Cam, Depth_PivotInstances )
	xCameraClsMode ( Cam, 1, 1 )

	For D = 0 To DepthEntities_Normal xSetEntityShaderLayer ( xGetChild( Depth_PivotNormal, D ), 0 ) : Next
	For D = 0 To DepthEntities_Instances xSetEntityShaderLayer ( xGetChild( Depth_PivotInstances, D ), 0 ) : Next
	xWireframe Wire	; debug
	;//////////////////////////////////////////

	xHideEntity Sun

	RenderWater Water_Plane,Cam


	If BlackLS
		xSetEffectVector Clouds, "CloudColor", 0,0,0
		xSetEffectFloat Clouds, "CloudPower" , 0
		
		xCameraViewport Cam, 0, 0, BlackTexX, BlackTexY
		xSetBuffer xTextureBuffer(BlackTex)
		xHideEntity Sky
		xShowEntity Sun
		xEntityAlpha Sun,1
		
		xEntityTexture Moon,Suntex
		
		xAmbientLight 0, 0, 0
		xCameraClsColor Cam, 0,0,0
		xLightColor LIGHT,0,0,0
		xRenderWorld ()
		xShowEntity Sky
		
		xEntityTexture Moon,Moontex

	EndIf
	
	Update_Ambient(Cam, LIGHT)	

	
	xCameraClsColor Cam, 100. , 100. , 100.

	xSetBuffer xBackBuffer()
	xCameraViewport Cam, 0, 0, ResX, ResY
	xRenderWorld()

	; Water Render ( Pass 2 - Refraction & Render  )
	; Use final backbuffer to make refraction with shadows
	xStretchBackBuffer(tTextureScreen, 0, 0, ResX, ResY, 0)
	xShowEntity Water_Plane
	xCameraClsMode Cam,0,0
	xRenderEntity Cam, Water_Plane
	xCameraClsMode Cam,1,1	
	xHideEntity Water_Plane
	;//////////////////////////////////////////
	
	
	; Post-Process
	LSPX# = -99
	LSPY# = -99
	If xEntityY(Sun,1) > -550
		xCameraProject Cam, xEntityX(Sun,1), xEntityY(Sun,1), xEntityZ(Sun,1)
		LSPX# = xProjectedX() / ResX
		LSPY# = xProjectedY() / ResY
		xSetPostEffectFloat PostPtocess_LightSca, "Leng", .92
		xSetPostEffectVector PostPtocess_LightSca, "SunPos", LSPX, LSPY, 1
	Else

		xCameraProject Cam, xEntityX(Moon,1), xEntityY(Moon,1), xEntityZ(Moon,1)
		LSPX# = xProjectedX() / ResX
		LSPY# = xProjectedY() / ResY
		xSetPostEffectFloat PostPtocess_LightSca, "Leng", .8
		xSetPostEffectVector PostPtocess_LightSca, "SunPos", LSPX, LSPY, 1
	EndIf

	If Abs(LSPX+LSPY) < 2
		BlackLS = True

		xSetPostEffect( 0, PostProcess_Bloom )
		xSetPostEffect( 1, PostPtocess_LightSca )
		
		xRenderPostEffects()
	Else
		BlackLS = False
		
		xSetPostEffect( 0, PostProcess_Bloom )
		xSetPostEffect( 1, 0 )
		xRenderPostEffects()

	EndIf
	
	
	If xKeyHit(Key_Space) Wire = 1- Wire : xWireframe Wire
	
	xColor 0,255,0
	xText 10,25*0,"FPS " + xGetFPS()
	xText 10,25*.6,"TIME " + BS_CalculateTime$()
;	xText 10,25*1.2, "SPEED " + BS_SunSpeed
	xText 10,25*1.8,"(Space) WIREFRAME " + Wire
	
	
	xFlip()

Wend




Function LoadWater(tModel%)

	Local tTextureNormalW, tTextureNormalN, Foam, Foam2, tTextureNormalH
	
	wCamera% = xCreateCamera()
	xCameraRange wCamera, 1 ,20000
	xHideEntity wCamera
	xCameraClsColor wCamera,60,90,150
	
	; load textures
	tTextureNormalW% = xLoadTexture("Water/Water_NormalW.png")
	tTextureNormalN% = xLoadTexture("Water/Water_NormalN.png")
	
	tTextureNormalH% = xLoadTexture("Water/Waves.png")
	
	
	Ratio# = WaterRes / (Float(ResX)/ResY)
	tTextureReflection% = xCreateTexture( WaterRes, Ratio )
	tTextureScreen%     = xCreateTexture( ResX, ResY )


	Foam = xLoadTexture("Water/Foam.png")
	Foam2 = xLoadTexture("Water/Foam.dds")
	

	; setup shader
	xSetEntityEffect tModel, Shader_Water
	xSetEffectTechnique tModel, "Water"

	xSetEffectTexture tModel,	"tNormalW", tTextureNormalW
	xSetEffectTexture tModel,	"tNormalN", tTextureNormalN
	xSetEffectTexture tModel,	"tNormalH1", tTextureNormalH
	
	
	xSetEffectTexture tModel,	"FoamTexture", Foam
	xSetEffectTexture tModel,	"FoamTexture2", Foam2
	
	xSetEffectTexture tModel,	"DepthTexture", DepthTex
	xSetEffectTexture tModel,	"tScreen", tTextureScreen
	xSetEffectTexture tModel,	"tReflection", tTextureReflection

	xSetEffectFloat tModel, 	"Alpha", 1
	xSetEffectVector tModel,	"TexScale", 0.08, 0.08, 0

	xSetEffectVector tModel,	"ReflectionColor", 0.8,0.8,0.8 
	xSetEffectVector tModel,	"RefractionColor", 0.082*3,0.15*3,0.17*3

	xSetEffectFloat tModel,		"Refract", 0.3
	xSetEffectFloat tModel,		"Reflect", 0.1

	xSetEffectVector tModel, 	"FogColor", 60. / 255, 90. / 255, 150. / 255

	xSetEffectFloat tModel, 	"ResX",ResX
	xSetEffectFloat tModel, 	"ResY",ResY

							
	xSetEffectFloat tModel, 	"Softness", 0.2						
	xSetEffectVector tModel, 	"WaterSpeed" , -0.004, -0.0045, 0.1, 0.02
	xSetEffectFloat  tModel, 	"WaveHeight" , .009				


End Function 



Function RenderWater(tModel%, gCamera%)


	; hide objects
	xHideEntity gCamera
	xShowEntity wCamera

	; Reflection
	xCameraViewport wCamera, 0, 0, WaterRes, Ratio
	ClipPlane wCamera, 0, -0.40, 0, 0, 1, 0, 0, 1 ; -0.299
	xPositionEntity wCamera, xEntityX(gCamera, True),  -xEntityY(gCamera, True), xEntityZ(gCamera, True), True
	xRotateEntity wCamera, -xEntityPitch(gCamera), xEntityYaw(gCamera), -xEntityRoll(gCamera)
	xSetBuffer xTextureBuffer(tTextureReflection)
	xRenderWorld 1,0

	
	xHideEntity wCamera


    ClipPlane wCamera, 0, 0, 0, 0, 0, 0, 0, 0
    xSetBuffer xBackBuffer()
    xShowEntity gCamera


	; Plane Position
	xTFormPoint 0,0,100,Cam,0
	xPositionEntity Water_Plane, xTFormedX(), 0, xTFormedZ()
	xRotateEntity Water_Plane,0,xEntityYaw(Cam,1) + 45,0

	x#=xEntityX(Water_Plane)-xEntityX(Cam)
	y#=xEntityZ(Water_Plane)-xEntityZ(Cam)
	AreaFx# = 66.6 + (Sqr#((x#*x#)+(y#*y#))/1.5)
	xSetEffectVector tModel, "ScaleVec", AreaFx, AreaFx, 1, 1

	xSetEffectVector tModel, "FogColor", (Float(SkyColorR[BS_Time]) / 255) , (Float(SkyColorG[BS_Time]) / 255) , (Float(SkyColorB[BS_Time]) / 255)

End Function


Function ClipPlane(camera%, x#, y#, z#, vx#, vy#, vz#, index% = 0, enable% = True)
   xCameraClipPlane camera, index, enable, vx, vy, vz, -vx * x - vy * y - vz * z
End Function


Function CreateWaterPlane(cols%, rows%, tileSize# = 1.0, inf = False)

   Local Mesh%    = xCreateMesh   ()
   Local Surf%    = xCreateSurface(Mesh)
   Local x#    = -(cols*tileSize)/2
   Local y#    = 0
   Local z#    = -(rows*tileSize)/2
   Local u#, v#
   Dim vx2%(cols,rows)

   ; CREATE VERTICES
   i = 0
   For row% = 0 To rows
      For col% = 0 To cols
         y = 0
         u  = col * (uv_scale/cols)
         v  = uv_scale - (row * (uv_scale/rows))
         u = col * (1.0/cols)
         v = 1.0 - (row * (1.0/rows))
         vx2(col,row) = xAddVertex(Surf, x + col*tileSize,y,z + row*tileSize)
      Next
   Next

   ; CREATE TRIANGLES
   For row% = 0 To rows-1
      For col% = 0 To cols-1
         xAddTriangle(Surf, vx2(col,row),vx2(col,row+1),vx2(col+1,row+1))
         xAddTriangle(Surf, vx2(col,row),vx2(col+1,row+1),vx2(col+1,row))
      Next
   Next

	; TO THE INF!
	For row% = 0 To rows
		xVertexCoords Surf,vx2(0,row),xVertexX(Surf,vx2(0,row))-6000,xVertexY(Surf,vx2(0,row)),xVertexZ(Surf,vx2(0,row) )
		xVertexCoords Surf,vx2(cols,row),xVertexX(Surf,vx2(cols,row))+6000,xVertexY(Surf,vx2(cols,row)),xVertexZ(Surf,vx2(cols,row) )
	Next
	
	For col% = 0 To cols
		xVertexCoords Surf,vx2(col,0),xVertexX(Surf,vx2(col,0)),xVertexY(Surf,vx2(col,0)),xVertexZ(Surf,vx2(col,0) )-6000
		xVertexCoords Surf,vx2(col,cols),xVertexX(Surf,vx2(col,cols)),xVertexY(Surf,vx2(col,cols)),xVertexZ(Surf,vx2(col,cols) )+6000
	Next

   xUpdateNormals Mesh

   Return Mesh

End Function

Function CurveValue#(newvalue#, oldvalue#, increments)
	If increments >  1 Then oldvalue# = oldvalue# - (oldvalue# - newvalue#) / increments 
	If increments <= 1 Then oldvalue# = newvalue# 
	Return oldvalue# 
End Function


;~IDEal Editor Parameters:
;~C#Blitz3D