
//##################  Variables  ##################
float4x4 WorldViewProjection 	:  MATRIX_WORLDVIEWPROJTRANSPOSE;

//################# Vars ##########################
float Leng = 1.0f;
float Decay = 0.99F;
float Exposition = 2.0f;
int numSamples = 32;
float2 SunPos;

//##################  Textures  ###################

const texture BlackTexture;
sampler BTexture = sampler_state {
    Texture   = <BlackTexture>;
    ADDRESSU  = WRAP;
    ADDRESSV  = WRAP;
    ADDRESSW  = WRAP;
    MAGFILTER = LINEAR;
    MINFILTER = LINEAR;
    MIPFILTER = LINEAR;
};

const texture CurrentB : CURRENTBUFFER;
sampler frameSampler = sampler_state {
    Texture   = <CurrentB>;
    ADDRESSU  = WRAP;
    ADDRESSV  = WRAP;
    ADDRESSW  = WRAP;
    MAGFILTER = LINEAR;
    MINFILTER = LINEAR;
    MIPFILTER = LINEAR;
};


const texture CurrentS : SCENECURRENT2X;
sampler frameSampler2 = sampler_state {
    Texture   = <CurrentS>;
    ADDRESSU  = WRAP;
    ADDRESSV  = WRAP;
    ADDRESSW  = WRAP;
    MAGFILTER = LINEAR;
    MINFILTER = LINEAR;
    MIPFILTER = LINEAR;
};


//###############  Output VS  ####################
struct pis {
	float2 TexCoords : TEXCOORD0;
};

//##################  PS  ########################
float4 psLightSca( in pis IN ) : COLOR {
  
  float4 sampleFrame = tex2D( frameSampler, IN.TexCoords );		
	
	//Exposition = 2 * ( 1 - saturate( abs(SunPos.x + SunPos.y) / 3 ) );


	float2 DeltaTex = IN.TexCoords - SunPos.xy; 	
	float2 NewUv = IN.TexCoords;
	float3 Scatter;
	float FallOff = 1.0;	

	DeltaTex *= ( 1.0f / numSamples ) * Leng;   

	float alp;

	for ( int i = 0; i < numSamples; i++ ) {		
		NewUv -= DeltaTex;
		alp = i;
		Scatter += tex2D( BTexture, NewUv ) * FallOff;						
		FallOff *= Decay;
	}
	Scatter /= numSamples;	


	float3 Flares = 0;

	Flares=pow(tex2D(BTexture,1-IN.TexCoords)*float3(0.3,0.25,0.25),3.5f);
	Flares=Flares+pow(tex2D(BTexture,0.75f-IN.TexCoords*0.5f)*float3(0.25,0.25,0.3),3.5f);
	Flares=Flares+pow(tex2D(BTexture,(IN.TexCoords*0.5f)+0.25f)*float3(0.25,0.3,0.25),3.5f);

	Scatter += Flares;

	return float4(Scatter * Exposition, 1) + (sampleFrame);

}

//##############  Technique  #####################
//------------------------------------------
technique MainTechnique {
	pass p0 {	
		pixelshader		= compile ps_3_0 psLightSca();
	}
}